/*
 ============================================================================
 Name        : Steph.cpp
 Author      : Fritz Sedlazeck
 Version     :
 Copyright   : artistic license
 Description : A little show case in C++,
 ============================================================================
 */

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include <sstream>
#include <map>
#include <math.h>
using namespace std;
map<string, bool> parse_names(string filename) {
	ifstream myfile;

	myfile.open(filename.c_str(), ifstream::in);
	if (!myfile.good()) {
		cout << "Could not open file: " << filename.c_str()
				<< endl;
		exit(0);
	}

	size_t buffer_size = 20000;
	char * buffer = new char[buffer_size];
	myfile.getline(buffer, buffer_size);
	map<string, bool> names;
	string name;
	while (!myfile.eof()) {
		int count=0;
		for (size_t i = 0;
				i < buffer_size && buffer[i] != '\n' && buffer[i] != '\0' && buffer[i] != ' ';
				i++) {
			if (buffer[i] == '_') {
				count++;
				if (count == 2) {
					break;
				}
			}
			name += buffer[i];
		}
		cout<<name<<endl;
		names[name] = true;
		name.clear();
		myfile.getline(buffer, buffer_size);
	}
	myfile.close();
	return names;
}

void extract_entries(string filename, string output, map<string, bool> names) {
	ifstream myfile;

	myfile.open(filename.c_str(), ifstream::in);
	if (!myfile.good()) {
		cout << "Could not open file: " << filename.c_str()
				<< endl;
		exit(0);
	}

	FILE *file2;
	file2 = fopen(output.c_str(), "w");
	if (file2 == NULL) {
		cout << "Error in printing: The file or path that you set " << output.c_str()
				<< " is not valid. It can be that there is no disc space available." << endl;
		exit(0);
	}

	size_t buffer_size = 2000000;
	char * buffer = new char[buffer_size];
	myfile.getline(buffer, buffer_size);
	fprintf(file2, "%s", buffer);
				fprintf(file2, "%c", '\n');
	string name;
	while (!myfile.eof()) {
		int count = 0;
		for (size_t i = 0;
				i < buffer_size && buffer[i] != '\n' && buffer[i] != '\r' && buffer[i] != '\0' && buffer[i] != '\t';
				i++) {
			if (buffer[i] == '_') {
				count++;
				if (count == 2) {
					break;
				}
			}
			name += buffer[i];

		}
//		cout<<name<<endl;
		if (names.find(name) != names.end()) {
			cout<<"hit"<<endl;
			fprintf(file2, "%s", buffer);
			fprintf(file2, "%c", '\n');
//			names.erase(name);
		}
//		if(names.empty()){
//			break;
//		}
		name.clear();
		myfile.getline(buffer, buffer_size);
	}
	myfile.close();
	fclose(file2);
}

int main(int argc, char **argv) {

	if (argc == 1) {
		cout<<"Possible options:"<<endl;
		cout << "1: Extract entries" << endl;
		return -1;
	}

	switch (atoi(argv[1])) {
	case 1:
		if (argc == 5) {
			cout<<"parse names"<<endl;
			map<string, bool> names = parse_names(string(argv[2]));
			cout<<"extract entries"<<endl;
			extract_entries(string(argv[3]), string(argv[4]), names);

		} else {
			cout << "1: Name file" << endl;
			cout << "2: Data Matrix" << endl;
			cout << "3: Output" << endl;
		}

		break;

	default:
		cerr<<"This is not a valid option!"<<endl;
		return -1;
		break;
	}


	return 0;
}
